/**
* High Availability Service (HA) for JOnAS
*
* Copyright (C) 2007,2008 Bull S.A.S.
* Copyright (C) 2006 Distributed Systems Lab.
* Universidad Politecnica de Madrid (Spain)
* Contact: http://lsd.ls.fi.upm.es/lsd
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
* USA
*
* --------------------------------------------------------------------------
*
* --------------------------------------------------------------------------
*/

package org.ow2.cmi.ha.interceptor.jrmp;

import org.ow2.carol.rmi.interceptor.api.JInitInfo;
import org.ow2.carol.rmi.interceptor.spi.JInitializer;
import org.ow2.util.log.Log;
import org.ow2.util.log.LogFactory;


/**
 * This class initializes the interception mechanism with jrmp.
 * @author Francisco Perez-Sorrosal (fpsorrosal@no-spam@fi.upm.es)
 * @author Alberto Paz-Jimenez (apaz@no-spam@fi.upm.es)
 */
public class HAInterceptorInitializer implements JInitializer {

    /**
     * Logger for traces
     */
    private static Log logger = LogFactory.getLog(HAInterceptorInitializer.class);

    /**
     * Initializes the HA client and server side interceptors
     */
    public void preInit(final JInitInfo info) {
        try {
            info.addClientRequestInterceptor(new HAClientInterceptor());
            info.addServerRequestInterceptor(new HAServerInterceptor());
        } catch (Exception e) {
            logger.error("Error while adding the request interceptors", e);
        }
    }

    public void postInit(final JInitInfo info) {
    }

}
